--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Tiles.Libraries.Packing is

    type A_Output_Proc is
        access procedure( msg : String; error : Boolean := False );

    function Pack_Library( libPath    : String;    -- path of output library
                           indexPath  : String;    -- path of input tile index
                           matrixPath : String;    -- path of input matrix index
                           compress   : Boolean;
                           Output     : A_Output_Proc
                         ) return Boolean;
    pragma Precondition( indexPath'Length > 0 );
    pragma Precondition( libPath'Length > 0 );

end Tiles.Libraries.Packing;
