--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private with Tools;

package Games.Ked is

private

    use Tools;

    type Ked_Game is new Game with
        record
            tool : A_Tool := null;
        end record;

    procedure Construct( this : access Ked_Game );

    procedure Delete( this : in out Ked_Game );

    procedure Add_Event_Listeners( this : access Ked_Game );

    procedure Handle_Event( this : access Ked_Game;
                            evt  : in out A_Event;
                            resp : out Response_Type );
    pragma Precondition( evt /= null );

    procedure New_Game( this : access Ked_Game );

    procedure Remove_Event_Listeners( this : access Ked_Game );

end Games.Ked;
