--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

private with Widgets.Buttons;
private with Widgets.Input_Boxes;

package Widgets.Containers.Panels.Dialogs.Open_World is

    function Create_Open_Dialog( view : not null access Game_Views.Game_View'Class;
                                 id   : String ) return A_Dialog;
    pragma Precondition( id'Length > 0 );
    pragma Postcondition( Create_Open_Dialog'Result /= null );

private

    use Widgets.Buttons;
    use Widgets.Input_Boxes;

    type Open_Dialog is new Dialog and
         Button_Listener and
         Input_Listener with null record;

    procedure Construct( this : access Open_Dialog;
                         view : not null access Game_Views.Game_View'Class;
                         id   : String );
    pragma Precondition( id'Length > 0 );

    procedure Handle_Action( this   : access Open_Dialog;
                             action : A_Button_Action );

    procedure Handle_Action( this   : access Open_Dialog;
                             action : A_Input_Action );

    procedure Handle_Action( this    : access Open_Dialog;
                             action  : A_Key_Action;
                             handled : out Boolean );

    procedure Handle_Show( this : access Open_Dialog );

    procedure Show( this : access Open_Dialog );

end Widgets.Containers.Panels.Dialogs.Open_World;
