--
-- Copyright (c) 2012 Kevin Wellwood
-- All rights reserved.
--
-- This source code is distributed under the Modified BSD License. For terms and
-- conditions, see license.txt.
--

package Maps.Keen is

private

    -- Keen maps have three layers and the two background layers are physical.
    type Keen_Map is new Map_Object with null record;
    type A_Keen_Map is access all Keen_Map'Class;

    -- This constructor is called to create a new empty map.
    procedure Construct( this : access Keen_Map; width, height : Positive );

    function Object_Input( stream : access Root_Stream_Type'Class ) return Keen_Map;
    for Keen_Map'Input use Object_Input;

    procedure Object_Read( stream : access Root_Stream_Type'Class; obj : out Keen_Map );
    for Keen_Map'Read use Object_Read;

    procedure Object_Write( stream : access Root_Stream_Type'Class; obj : Keen_Map );
    for Keen_Map'Write use Object_Write;

end Maps.Keen;
